/*************
	This is the unminified version of functions specific to Stonehenge EM OSM.
	The minified version is already included in Stonehenge_EM_OSM_Maps::output_single_admin_map();
*************/

/* Hide if "No Location" is checked. */
jQuery('#no-location').change(function(){
	if( jQuery('#no-location').is(':checked') ){
		jQuery('#em-location-data').hide();
		jQuery("#loc-id").val('');
		jQuery("#location-latitude").val('');
		jQuery("#location-longitude").val('');
		if( jQuery("#location-select-id").length ) {
			jQuery("#location-select-id option[value='0']").prop("selected", "selected");
			var newBalloon 	= jQuery("#location-select-id option:selected").text();
		}
	}else{
		jQuery('#em-location-data').show();
		jQuery("#location-id").val( locID );
		jQuery("#location-latitude").val(Lat);
		jQuery("#location-longitude").val(Lng);

	}
}).trigger('change');

/* Location Select */
jQuery('#location-select-id').change(function(){
	var Coords	 	= jQuery("#location-select-id option:selected").attr('title').split(",");
	var newLat 		= Coords[0];
	var newLng 		= Coords[1];
	var newLatLng 	= new L.LatLng(newLat, newLng);
	var newBalloon 	= jQuery("#location-select-id option:selected").text();
	var LocID 		= jQuery("#location-select-id option:selected").val();

	jQuery("#location-latitude").val(newLat);
	jQuery("#location-longitude").val(newLng);
	jQuery('#location-id').val( LocID );

	// Clear fields
	if( LocID == '0' ) {
		jQuery("#location-latitude").val('');
		jQuery("#location-longitude").val('');
		jQuery('#location-id').val('');
		marker.setLatLng([0,0]).bindPopup(newBalloon);
		map.setView([0,0],1);
	}
	else {
		marker.setLatLng(newLatLng).bindPopup(newBalloon).openPopup();
		map.setView(newLatLng, zoomLevel);
	}
}).trigger('change');


/* Is marker draggable? */
if( (jQuery("#location-name").length > 0) || (jQuery("#location-select-id").length) ) {
	marker.dragging.disable();
} else {
	marker.dragging.enable();
	marker.on('dragend', function(e) {
		jQuery('#location-latitude').val( marker.getLatLng().lat );
		jQuery('#location-longitude').val( marker.getLatLng().lng );
	});
}

/* OSM OpenCage API Search */
function apiSearch() {
	geoAddress( document.getElementById('location-address').value +', '+ document.getElementById('location-town').value +', '+ 		document.getElementById('location-postcode').value +', '+ document.getElementById('location-state').value );
}

function geoAddress(query) {
    jQuery.ajax({
        url: 'https://api.opencagedata.com/geocode/v1/json',
        method: 'GET',
        data: {
            'key': '<?php echo $api; ?>',
            'q': query,
            'no_annotations': 1,
            'add_request': 1,
            'pretty': 1,
            'language': locale,
        },
        dataType: 'json',
        statusCode: {
            200: function(response) {
                var result = response.results[0];
				console.log(result);
				var formatted = result.formatted;
				var components = result['components']
				if( components.city ) 		{ jQuery('#location-town').val( components.city );}
				if( components.town ) 		{ jQuery('#location-town').val( components.town );}
				if( components.village ) 	{ jQuery('#location-town').val( components.village );}
				if( components.state ) 		{ jQuery('#location-state').val( components.state );}
				if( components.county ) 	{ jQuery('#location-region').val( components.county );}
				if( components.postcode ) 	{ jQuery('#location-postcode').val( components.postcode );}
				if( components.country_code ) {
					var countryCode = components.country_code.toUpperCase();
					jQuery('#location-country').val( countryCode );
				}
				var newLat = result['geometry']['lat'];
				var newLng = result['geometry']['lng'];
				var newLatLng = new L.LatLng(newLat, newLng);
				jQuery('#location-latitude').val( newLat );
				jQuery('#location-longitude').val( newLng );

				marker.setLatLng(newLatLng).bindPopup(formatted).openPopup();
				map.setView(newLatLng, zoomLevel);
				},
            402: function() {
                console.log('hit free-trial daily limit');
                console.log('become a customer: https://opencagedata.com/pricing');
            }
        }
    });
}
